Index: instruments.xml
===================================================================
--- instruments.xml	(revision 3992)
+++ instruments.xml	(working copy)
@@ -4407,13 +4407,13 @@
           </channel>
         </instrument>
      <instrument>
-        <name>Soprano Viola da gamba</name>
-        <short-name>S. Vla. d. g.</short-name>
+        <name>Pardessus de viole</name>
+        <short-name>Pds. v.</short-name>
         <clef>9</clef>
-        <aPitchRange>50-86</aPitchRange>
-        <pPitchRange>50-93</pPitchRange>
+        <aPitchRange>55-91</aPitchRange>
+        <pPitchRange>55-96</pPitchRange>
         <channel>
-           <program>110</program>
+           <program>40</program>
            </channel>
         <channel name="pizzicato">
           <program value="45"/>
@@ -4424,13 +4424,13 @@
         <extended>1</extended>
         </instrument>
      <instrument>
-        <name>Alto Viola da gamba</name>
-        <short-name>A. Vla. d. g.</short-name>
+        <name>Treble Viol</name>
+        <short-name>Tr. v.</short-name>
         <clef>11</clef>
-        <aPitchRange>45-81</aPitchRange>
-        <pPitchRange>45-88</pPitchRange>
+        <aPitchRange>50-86</aPitchRange>
+        <pPitchRange>50-91</pPitchRange>
         <channel>
-           <program>110</program>
+           <program>40</program>
            </channel>
         <channel name="pizzicato">
           <program value="45"/>
@@ -4441,13 +4441,13 @@
         <extended>1</extended>
         </instrument>
      <instrument>
-        <name>Tenor Viola da gamba</name>
-        <short-name>T. Vla. d. g.</short-name>
+        <name>Tenor Viol</name>
+        <short-name>Ten. V.</short-name>
         <clef>12</clef>
         <aPitchRange>43-79</aPitchRange>
-        <pPitchRange>43-86</pPitchRange>
+        <pPitchRange>43-84</pPitchRange>
         <channel>
-           <program>110</program>
+           <program>41</program>
            </channel>
         <channel name="pizzicato">
           <program value="45"/>
@@ -4459,12 +4459,12 @@
         </instrument>
      <instrument>
         <name>Viola da gamba</name>
-        <short-name>Vla. d. g.</short-name>
+        <short-name>V. d. g.</short-name>
         <clef>4</clef>
         <aPitchRange>38-74</aPitchRange>
-        <pPitchRange>38-81</pPitchRange>
+        <pPitchRange>38-79</pPitchRange>
         <channel>
-           <program>110</program>
+           <program>42</program>
            </channel>
         <channel name="pizzicato">
           <program value="45"/>
@@ -4474,6 +4474,22 @@
           </channel>
         </instrument>
      <instrument>
+        <name>Viola da gamba (7 strings)</name>
+        <short-name>V. d. g.</short-name>
+        <clef>4</clef>
+        <aPitchRange>33-74</aPitchRange>
+        <pPitchRange>33-79</pPitchRange>
+        <channel>
+           <program>42</program>
+           </channel>
+        <channel name="pizzicato">
+          <program value="45"/>
+          </channel>
+        <channel name="tremolo">
+          <program value="44"/>
+          </channel>
+        </instrument>
+     <instrument>
         <name>Violoncello</name>
         <short-name>Vlc.</short-name>
         <clef>4</clef>
Index: instruments_de.xml
===================================================================
--- instruments_de.xml	(revision 3992)
+++ instruments_de.xml	(working copy)
@@ -755,6 +755,89 @@
            <program value="44"/>
            </channel>
           </instrument>
+     <instrument>
+        <name>Pardessus de viole</name>
+        <short-name>Pds. v.</short-name>
+        <clef>9</clef>
+        <aPitchRange>55-91</aPitchRange>
+        <pPitchRange>55-96</pPitchRange>
+        <channel>
+           <program>40</program>
+           </channel>
+        <channel name="pizzicato">
+          <program value="45"/>
+          </channel>
+        <channel name="tremolo">
+          <program value="44"/>
+          </channel>
+        <extended>1</extended>
+        </instrument>
+     <instrument>
+        <name>Diskant Gambe</name>
+        <short-name>D. G.</short-name>
+        <clef>11</clef>
+        <aPitchRange>50-86</aPitchRange>
+        <pPitchRange>50-91</pPitchRange>
+        <channel>
+           <program>40</program>
+           </channel>
+        <channel name="pizzicato">
+          <program value="45"/>
+          </channel>
+        <channel name="tremolo">
+          <program value="44"/>
+          </channel>
+        <extended>1</extended>
+        </instrument>
+     <instrument>
+        <name>Tenor Gambe</name>
+        <short-name>T. G.</short-name>
+        <clef>12</clef>
+        <aPitchRange>43-79</aPitchRange>
+        <pPitchRange>43-84</pPitchRange>
+        <channel>
+           <program>41</program>
+           </channel>
+        <channel name="pizzicato">
+          <program value="45"/>
+          </channel>
+        <channel name="tremolo">
+          <program value="44"/>
+          </channel>
+        <extended>1</extended>
+        </instrument>
+     <instrument>
+        <name>Viola da gamba</name>
+        <short-name>V. d. g.</short-name>
+        <clef>4</clef>
+        <aPitchRange>38-74</aPitchRange>
+        <pPitchRange>38-79</pPitchRange>
+        <channel>
+           <program>42</program>
+           </channel>
+        <channel name="pizzicato">
+          <program value="45"/>
+          </channel>
+        <channel name="tremolo">
+          <program value="44"/>
+          </channel>
+        </instrument>
+     <instrument>
+        <name>Viola da gamba (7 saiten)</name>
+        <short-name>V. d. g.</short-name>
+        <clef>4</clef>
+        <aPitchRange>33-74</aPitchRange>
+        <pPitchRange>33-79</pPitchRange>
+        <channel>
+           <program>42</program>
+           </channel>
+        <channel name="pizzicato">
+          <program value="45"/>
+          </channel>
+        <channel name="tremolo">
+          <program value="44"/>
+          </channel>
+        </instrument>
       <instrument>
          <name>Violoncello</name>
          <short-name>Vlc.</short-name>
Index: instruments_fr.xml
===================================================================
--- instruments_fr.xml	(revision 3992)
+++ instruments_fr.xml	(working copy)
@@ -895,6 +895,89 @@
            <program value="44"/>
            </channel>
          </instrument>
+     <instrument>
+        <name>Pardessus de viole</name>
+        <short-name>Pds. v.</short-name>
+        <clef>9</clef>
+        <aPitchRange>55-91</aPitchRange>
+        <pPitchRange>55-96</pPitchRange>
+        <channel>
+           <program>40</program>
+           </channel>
+        <channel name="pizzicato">
+          <program value="45"/>
+          </channel>
+        <channel name="tremolo">
+          <program value="44"/>
+          </channel>
+        <extended>1</extended>
+        </instrument>
+     <instrument>
+        <name>Dessus de viole</name>
+        <short-name>D. v.</short-name>
+        <clef>11</clef>
+        <aPitchRange>50-86</aPitchRange>
+        <pPitchRange>50-91</pPitchRange>
+        <channel>
+           <program>40</program>
+           </channel>
+        <channel name="pizzicato">
+          <program value="45"/>
+          </channel>
+        <channel name="tremolo">
+          <program value="44"/>
+          </channel>
+        <extended>1</extended>
+        </instrument>
+     <instrument>
+        <name>Taille de viole</name>
+        <short-name>T. v.</short-name>
+        <clef>12</clef>
+        <aPitchRange>43-79</aPitchRange>
+        <pPitchRange>43-84</pPitchRange>
+        <channel>
+           <program>41</program>
+           </channel>
+        <channel name="pizzicato">
+          <program value="45"/>
+          </channel>
+        <channel name="tremolo">
+          <program value="44"/>
+          </channel>
+        <extended>1</extended>
+        </instrument>
+     <instrument>
+        <name>Basse de viole</name>
+        <short-name>B. v.</short-name>
+        <clef>4</clef>
+        <aPitchRange>38-74</aPitchRange>
+        <pPitchRange>38-79</pPitchRange>
+        <channel>
+           <program>42</program>
+           </channel>
+        <channel name="pizzicato">
+          <program value="45"/>
+          </channel>
+        <channel name="tremolo">
+          <program value="44"/>
+          </channel>
+        </instrument>
+     <instrument>
+        <name>Basse de viole (7 cordes)</name>
+        <short-name>B. v.</short-name>
+        <clef>4</clef>
+        <aPitchRange>33-74</aPitchRange>
+        <pPitchRange>33-79</pPitchRange>
+        <channel>
+           <program>42</program>
+           </channel>
+        <channel name="pizzicato">
+          <program value="45"/>
+          </channel>
+        <channel name="tremolo">
+          <program value="44"/>
+          </channel>
+        </instrument>
       <instrument>
          <name>Violoncelle</name>
          <short-name>Vlc.</short-name>
Index: instruments_it.xml
===================================================================
--- instruments_it.xml	(revision 3992)
+++ instruments_it.xml	(working copy)
@@ -4547,13 +4547,13 @@
           </channel>
         </instrument>
      <instrument>
-        <name>Viola da gamba soprano</name>
-        <short-name>S. Vla. d. g.</short-name>
+        <name>Pardessus de viole</name>
+        <short-name>Pds. v.</short-name>
         <clef>9</clef>
-        <aPitchRange>50-86</aPitchRange>
-        <pPitchRange>50-93</pPitchRange>
+        <aPitchRange>55-91</aPitchRange>
+        <pPitchRange>55-96</pPitchRange>
         <channel>
-           <program>110</program>
+           <program>40</program>
            </channel>
         <channel name="pizzicato">
           <program value="45"/>
@@ -4564,13 +4564,13 @@
         <extended>1</extended>
         </instrument>
      <instrument>
-        <name>Viola da gamba contralto</name>
-        <short-name>A. Vla. d. g.</short-name>
+        <name>Viola soprano<name>
+        <short-name>V. s.</short-name>
         <clef>11</clef>
-        <aPitchRange>45-81</aPitchRange>
-        <pPitchRange>45-88</pPitchRange>
+        <aPitchRange>50-86</aPitchRange>
+        <pPitchRange>50-91</pPitchRange>
         <channel>
-           <program>110</program>
+           <program>40</program>
            </channel>
         <channel name="pizzicato">
           <program value="45"/>
@@ -4581,13 +4581,13 @@
         <extended>1</extended>
         </instrument>
      <instrument>
-        <name>Viola da gamba tenore</name>
-        <short-name>T. Vla. d. g.</short-name>
+        <name>Viola tenore</name>
+        <short-name>V. t.</short-name>
         <clef>12</clef>
         <aPitchRange>43-79</aPitchRange>
-        <pPitchRange>43-86</pPitchRange>
+        <pPitchRange>43-84</pPitchRange>
         <channel>
-           <program>110</program>
+           <program>41</program>
            </channel>
         <channel name="pizzicato">
           <program value="45"/>
@@ -4599,12 +4599,12 @@
         </instrument>
      <instrument>
         <name>Viola da gamba</name>
-        <short-name>Vla d. g.</short-name>
+        <short-name>V. d. g.</short-name>
         <clef>4</clef>
         <aPitchRange>38-74</aPitchRange>
-        <pPitchRange>38-81</pPitchRange>
+        <pPitchRange>38-79</pPitchRange>
         <channel>
-           <program>110</program>
+           <program>42</program>
            </channel>
         <channel name="pizzicato">
           <program value="45"/>
@@ -4614,6 +4614,22 @@
           </channel>
         </instrument>
      <instrument>
+        <name>Viola da gamba (7 corde)</name>
+        <short-name>V. d. g.</short-name>
+        <clef>4</clef>
+        <aPitchRange>33-74</aPitchRange>
+        <pPitchRange>33-79</pPitchRange>
+        <channel>
+           <program>42</program>
+           </channel>
+        <channel name="pizzicato">
+          <program value="45"/>
+          </channel>
+        <channel name="tremolo">
+          <program value="44"/>
+          </channel>
+        </instrument>
+     <instrument>
         <name>Violoncello</name>
         <short-name>Vcello</short-name>
         <clef>4</clef>